/* Crediti : TTS.js  stato realizzando grazie all' open source speechsynthesis by "jdsmith3000, ststimac, stevebe" , presente su  :    https://developer.microsoft.com/en-us/microsoft-edge/testdrive/demos/speechsynthesis/ ( link non pi disponibilie ).
   In seguito modificato da civic71 ( https://gamequiz.altervista.org ) per GameMakerStudio ed il modulo HTML5 ( ultima modifica 03/11/2021 )
*/


var TTS_VoiceWork = 'speechSynthesis' in window; // Testing for browser support
var TTS_N         = 0;      
var TTS_Voices    = speechSynthesis.getVoices(); // Lasciarlo come preload al caricamento del file JS


/* *********************************************  VOICE WORK ???  **************************************************************** */

function  TTS_Get_Voice_Work()    { if (TTS_VoiceWork == false){ TTS_VoiceWork = 'speechSynthesis' in window; }
                                    return TTS_VoiceWork ;
                                  }

/* *********************************************  CANCEL VOICE : stop ************************************************************ */

function  TTS_Stop()              { window.speechSynthesis.cancel(); }

/* *********************************************  PAUSE and RESUME VOICE ********************************************************* */

function  TTS_Pause(TTS_isPaused) { if (TTS_isPaused == true) { window.speechSynthesis.pause();  }
                                                         else { window.speechSynthesis.resume(); }
		                  }
   
/* *********************************************  PLAY  VOICE  ******************************************************************* */

function TTS_Play(TTS_Voice_Select,TTS_Text,TTS_Volume,TTS_Rate,TTS_Pitch) { 
                
	      var  speak          = function () {
                                                 var TTS_UffaVoce              = speechSynthesis.getVoices();  

		                                 var TTS_synEspressione        = new SpeechSynthesisUtterance();
		                                     TTS_synEspressione.text   = TTS_Text;    		                             
		                                     TTS_synEspressione.volume = TTS_Volume;  
		                                     TTS_synEspressione.rate   = TTS_Rate;
		                                     TTS_synEspressione.pitch  = TTS_Pitch;   
		                                     TTS_synEspressione.lang   = 1;  // it-it
                                                     TTS_synEspressione.voice  = TTS_UffaVoce[TTS_Voice_Select];  

                                                     window.speechSynthesis.speak(TTS_synEspressione); 
	                                        };

 
	        if ((TTS_VoiceWork) && (TTS_Text.length > 0)) { speak(); } // AUTOSTART 
}

/* **************************************  CONTROLL VOICE SPEAKING   *************************************************************** */

function  TTS_Speaking() { var bbb;
                             if (speechSynthesis.speaking) { bbb=true;   } 
                                                       else{ bbb=false;  }
                             return bbb;  
                         }

/* ************************************   REPORTS TOTAL NUMBER OF VOICES  *********************************************************** */

function  TTS_Get_Total_Number_Voice() { var    TTS_N_Totale_Di_Voci      = 0;
                                         var    TTS_INFO_N_Totale_Di_Voci = speechSynthesis.getVoices();                                     
                                                TTS_INFO_N_Totale_Di_Voci.forEach((voice,index,arr) => { TTS_N_Totale_Di_Voci = index; }); 
 
                                         return TTS_N_Totale_Di_Voci ;
                                       }

/* **********************************     SHOW NAME OF YOUR AVAILABLE VOICES  ******************************************************* */

function  TTS_Get_Voice_Name(TTS_X){ var TTS_GET_NOME_Voce = speechSynthesis.getVoices();
                                     var bubu = "Sorry, no voice detected !!"; 
                                     TTS_GET_NOME_Voce.forEach((voice,index,arr) => { if (index>0) { bubu = TTS_GET_NOME_Voce[TTS_X].name; }});
                                     return bubu;                               
                                   }

/* **********************************     EXTRA : CREATE OPTION INPUTS TO SELECT A VOICE   ****************************************** */

var TTS_optionExists = false;

var TTS_mySelect = document.createElement( 'select' );
     TTS_mySelect.style.position     = 'absolute';
     TTS_mySelect.style.visibility   = "hidden";
     TTS_mySelect.style.background   = "rgb(20,20,20)";
     TTS_mySelect.style.zIndex       = "9000";
     TTS_mySelect.style.color        = "#aaffff";
     TTS_mySelect.style.fontSize     = "17px";
     TTS_mySelect.value              = 0;

function TTS_SelectVoice(TTS_mySelectLeft,TTS_mySelectTop) { var voices = speechSynthesis.getVoices();                        


                                                          if (TTS_optionExists == false) { TTS_optionExists = true;

                                                                                     TTS_mySelect.style.visibility   = "visible";
                                                                                     TTS_mySelect.style.top   = String(TTS_mySelectTop)+"px";
                                                                                     TTS_mySelect.style.left  = String(TTS_mySelectLeft)+"px";

                                                                                            document.body.appendChild( TTS_mySelect );

                                                                                            voices.forEach((voice,index,arr) => {  
                                                                                             var TTS_option = document.createElement('option');
                                                                                             TTS_option.value     = index;
			                                                                     TTS_option.innerHTML = voice.name;
			                                                                     TTS_mySelect.appendChild(TTS_option);
		                                                                             });
                                                                                           } 
                                                                                      else { return TTS_mySelect.value; }

	                                                };



/* ******************************   EXTRA : CREATE BUTTONS TO SELECT A VOICE  *************************************************** */

var TTS_ButtonsExists  = false;
var TTS_ButtonsSelezionato = 0;

function TTS_ButtonsVoices(TTS_myLeft,TTS_myTop,TTS_quale_voce)  {    

               if (TTS_ButtonsExists == false) { 
                                                 var esiste = document.getElementById(TTS_quale_voce);
                                                 if ((esiste!=undefined) || (TTS_quale_voce==10000)){ TTS_ButtonsExists = true; }

                                                var TTS_Voices_B = speechSynthesis.getVoices();
                                                    TTS_Voices_B.forEach((voice,index,arr) => { 
                                                 
                                                if ( (TTS_quale_voce==10000)||(TTS_quale_voce==index) ){   
         
                                                var TTS_Button                    = document.createElement('button');
                                                    TTS_Button.style.position     = 'absolute';
                                                    TTS_Button.style.left         = String(TTS_myLeft)+"px";
                       if  (TTS_quale_voce==10000){ TTS_Button.style.top          = String(TTS_myTop+(42*index))+"px"; }
                                              else{ TTS_Button.style.top          = String(TTS_myTop)+"px"; }
                                                    TTS_Button.style.width        = "512px";
                                                    TTS_Button.style.height       = "32px";
                                                    TTS_Button.value              = index;
                                                    TTS_Button.id                 = index;
                                                    TTS_Button.innerHTML          = String(index)+" &nbsp; "+String(TTS_Voices_B[index].name);
                                                    TTS_Button.style.textAlign    = "left";
                                                    TTS_Button.style.fontSize     = "15px";
                                                    TTS_Button.style.color        = "#000000";
                                                    TTS_Button.style.background   = "#ffffff";
                                                    TTS_Button.style.borderRadius = "15px"; 
                                                    TTS_Button.style.paddingLeft  = "15px";
                                                    TTS_Button.onclick    = function() { TTS_ButtonsSelezionato = this.value; };
                                                    document.body.appendChild( TTS_Button );
                                                    }
                                                   });

                                                }

                                 return TTS_ButtonsSelezionato;
 
                              }

/* ******************************   EXTRA  DRAW  ALL VOICE NAME FOR THIS BROWSER    ************************************************** */

var TTS_Info = document.createElement( 'div' );
     TTS_Info.style.position     = 'absolute';
     TTS_Info.style.top          = '100px';
     TTS_Info.style.left         = '20%';
     TTS_Info.style.fontSize     = '17px';
     TTS_Info.style.color        = "rgb(200,200,20)";
     TTS_Info.style.width        = '50%';
     TTS_Info.style.height       = '1px';
     TTS_Info.style.textAlign    = 'left';
     TTS_Info.style.paddingLeft  = "20px";
     TTS_Info.style.zIndex       = "9000";
     TTS_Info.style.background   = "rgb(20,20,20)"; 
     TTS_Info.style.borderRadius = "12px 20px";
     TTS_Info.style.visibility   = "hidden";
     document.body.appendChild( TTS_Info );


TTS_DrawVoices = function () { 
                               var  TTS_DrawAllVoice = "";
                               var  TTS_Voices_N     = speechSynthesis.getVoices(); 
                               var  TTS_Voices_Q     = 0;                                                             

                               TTS_Voices_N.forEach((voice,index,arr) => { TTS_Voices_Q      = index+1;
                                                                           TTS_DrawAllVoice += index +' : '+arr[index].name+'<br/>';
                                                                         });

                              var TTS_Draw_X  = "<br/><b>All voice ( "; 
                                   TTS_Draw_X += String(TTS_Voices_Q);
                                    TTS_Draw_X += " )</b><br/><br/>";
                                     TTS_Draw_X +=TTS_DrawAllVoice+'<br/>&nbsp;<br/>';


                               TTS_Info.innerHTML        = TTS_Draw_X;
                               TTS_Info.style.height     = String(100+(TTS_Voices_Q*22))+"px";
                               TTS_Info.style.visibility = "visible";
                             }



function TTS_DrawInfoVoice(TTS_InfoLeft,TTS_InfoTop,okDraw) { 
                                                               TTS_Info.style.left = String(TTS_InfoLeft)+"px";
                                                               TTS_Info.style.top  = String(TTS_InfoTop)+"px";

                                    if (okDraw==true){ okDraw = 2;
                                                       if (TTS_VoiceWork) { TTS_DrawVoices();  /* per old Edge  */
                                                                           /* Per Chrome, Opera, Firefox, Edge Chromiun : */
		                                                          window.speechSynthesis.onvoiceschanged = () => { TTS_DrawVoices(); }; 
                                                                          } 
                                                     }

                                    if (okDraw==false){ okDraw = 2;
                                                        TTS_Info.style.height     = '1px';
                                                        TTS_Info.style.visibility = "hidden";
                                                      }
                                   }
