/// TTS Variables 
TTS_Info_Voice_Work     = false; /* if TTS.js works in this browser   -   se TTS.js funziona in questo browser */
TTS_Total_Number_Voice  = 0;     /* the total of available voices     -   il totale delle voci disponibili */
TTS_Voice_Selected      = 0;     /* number of the selected voices     -   numero della voce selezinata */
TTS_Volume              = 1;     /* volume from 0 a 1 */
TTS_Rate                = 0.8;   /* text reading speed                -   velocità di lettura del testo */
TTS_Pitch               = 1;     /* Pitch da 0 a 2; */
TTS_Voice_Name[0]       = "Sorry, this platform does not support Text to Speech !!";


/* Code used only in browsers        Codice utilizzato solo nei browser */
if ( os_browser != browser_not_a_browser) {    
    /* We assign to the TTS_Info_Voice_Work variable whether the browser is enabled for speech synthesis or not: true or false;
       Assegnamo alla variabile TTS_Info_Voice_Work se il browser è o meno abilitato alla sintesi vocale : true o false; 
    */
    TTS_Info_Voice_Work    = TTS_Get_Voice_Work(); 
    
     /* We assign the total number of voices to the TTS_Total_Number_Voice variable.
        Assegnamo alla variabile TTS_Total_Number_Voice il numero totale di voci trovate.
     */
     
    if ( TTS_Info_Voice_Work == true){ TTS_Total_Number_Voice = real( TTS_Get_Total_Number_Voice() ); }
    
    
    
    /* If everything works in this browser, a for is done
       By creating the variables TTS_Voice_Name [1], TTS_Voice_Name [2], etc ...;
       on the basis of the number of items detected and we assign the relative name to them.
        
       Se tutto funziona in questo browser, viene fatto un for
       Creando le variabili TTS_Voice_Name[1], TTS_Voice_Name[2], ecc...;
       in base al numero di voci rilevate ed assegnamo ad esse il relativo nome.
    */
    if ( ( TTS_Info_Voice_Work == true) && (TTS_Total_Number_Voice>0)) {
       for (i = 0; i< TTS_Total_Number_Voice+1 ; i++; ){

                  TTS_Voice_Name[i] = TTS_Get_Voice_Name(i);
                                    
                }
      }
      
    if (( TTS_Info_Voice_Work == true)&&( ! TTS_Total_Number_Voice>0)){ alarm[0]= 10; }
  
}
