///scr_TTS_Voice_Button( x,y,number voice or TTS_Voice_Selected or 10000 );

/* ENG :
Create a clickable button, for each voices present, outside the canvas and using the browser's default font.
  argument0: position x;
  argument1: position y; 
  argument2: number of the voices to be drawn; 
             or enter TTS_Voice_Selected which corresponds to the number of the selected voice;
             if 10000 create button for all the voices;
    
ITA :   
Crea un bottone cliccabile, per ogni voce presente;, al di fuori del canvas ed utilizzando il font di default del browser. 
Non è possibile utilizzare questa funzione più volte ( per esempio per creare più bottoni in differenti posizioni ) .
 argument0 : posizione x;  
 argument1 : posizione y;  
 argument2 : numero della voce da disegnare; 
             inserisci TTS_Voice_Selected per il numero della voce selezionata;
             Inserisci 10000 affinchè vengano creati per tutte le voci; 
*/

if ( os_browser != browser_not_a_browser) { // solo se è un browser 
 if (( TTS_Info_Voice_Work == true) && (TTS_Total_Number_Voice>0)){                        

  TTS_Voice_Selected = TTS_ButtonsVoices(argument0 , argument1, argument2 );   // Add buttons;
 }
}
                                     
